

#property copyright "roi"
#property link      ""
#include <stderror.mqh>
#include <stdlib.mqh>
extern int TrailingStop=30;
extern double Lots=0.1;
extern int StartHour=16;
extern int CloseHour=11;
extern int gmt_offset=0;
extern string If_You_Have_A_5_Digit_Broker;
extern int  Dealer_Digits=5;
extern bool UseMoneyManagement = false;
extern bool AccountIsMicro = false;
extern int Risk = 10; // risk in percentage % (10% of risk in this case)
int MagicNumber = 0;
extern int Magic=1234;
bool  Open_Trades,Pending_Trades,Traded_Today=false;
double Upper_Limit,Lower_Limit;



bool SetObjectText(string name, string text, string font, int size, color Acolor)
{
   return(ObjectSetText(name, text, size, font, Acolor));
}

bool MoveObject(string name, int type, datetime Atime, double Aprice, datetime Atime2 = 0, double Aprice2 = 0, color Acolor = CLR_NONE, int Aweight = 0, int Astyle = 0)
{
   if (ObjectFind(name) != -1) {
      int OType = ObjectType(name);

      if ((OType == OBJ_VLINE) ||
         (OType == OBJ_HLINE) ||
         (OType == OBJ_TRENDBYANGLE) ||
         (OType == OBJ_TEXT) ||
         (OType == OBJ_ARROW) ||
         (OType == OBJ_LABEL)) {
         return(ObjectMove(name, 0, Atime, Aprice));
      }

      if ((OType == OBJ_GANNLINE) ||
         (OType == OBJ_GANNFAN) ||
         (OType == OBJ_GANNGRID) ||
         (OType == OBJ_FIBO) ||
         (OType == OBJ_FIBOTIMES) ||
         (OType == OBJ_FIBOFAN) ||
         (OType == OBJ_FIBOARC) ||
         (OType == OBJ_RECTANGLE) ||
         (OType == OBJ_ELLIPSE) ||
         (OType == OBJ_CYCLES) ||
         (OType == OBJ_TREND) ||
         (OType == OBJ_STDDEVCHANNEL) ||
         (OType == OBJ_REGRESSION)) {
         return(ObjectMove(name, 0, Atime, Aprice) && ObjectMove(name, 1, Atime2, Aprice2));
      }
   }
   else {
      return(ObjectCreate(name, type, 0, Atime, Aprice, Atime2, Aprice2, 0, 0) && ObjectSet(name, OBJPROP_COLOR, Acolor));
   }
}

int init()
  {
   return(0);
  }
  
int deinit()
  {
   return(0);
  }

void CheckTrade(int Magic) //checks for open or pending trades
{
   Open_Trades=false;Pending_Trades=false; // both false until they're not...
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES); 
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic &&(OrderType()==OP_BUY||OrderType()==OP_SELL)) 
      {  Open_Trades=true;
         Close_Pending(Magic); // if there's an open trade then close the pending orders 
      }
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic &&(OrderType()==OP_BUYSTOP||OrderType()==OP_SELLSTOP)) Pending_Trades=true;
  }
}

void Close_Pending(int Magic) //closes all pending trades
{
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES); 
      if((OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP) && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) OrderDelete(OrderTicket(),Green);
   }
   Pending_Trades=false;
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   if(UseMoneyManagement==true) {
      Lots = MM(); //Adjust the lot size     total

   }
        TP();

if(Dealer_Digits==0) Dealer_Digits=Digits; // lets user set it to 5 manually
int i=1;
Comment(
   "Hour =",Hour()," and Minute=",Minute()," and GMT Offset=",gmt_offset,"\n",
   "Upper Limit=",Upper_Limit,"\n",
   "Lower Limit=",Lower_Limit,"\n",
   "Traded Today  =",Traded_Today
   );

if(Hour()<=CloseHour+gmt_offset && iVolume(NULL,240,0)<10) 
{
   Close_Pending(Magic);  // expires all the open orders at midnight
   Traded_Today=false;  // prevents opening a new pending order on the same day that one already executed
}

CheckTrade(Magic);

   Upper_Limit=NormalizeDouble(High[iHighest(NULL,PERIOD_H1,MODE_HIGH,10,1)],Dealer_Digits);
   Lower_Limit=NormalizeDouble(Low[iLowest(NULL,PERIOD_H1,MODE_LOW,10,1)],Dealer_Digits);
   
//+---------------------------------------------------------------------------------------+
MoveObject("VH",OBJ_HLINE,Time[0],Upper_Limit,Time[0],Upper_Limit,DarkGreen,1,STYLE_SOLID);
SetObjectText("VH_txt","VH Zone","Arial",7,Black);
MoveObject("VH_txt",OBJ_TEXT,Time[0],Upper_Limit,Time[0],Upper_Limit,DarkGreen);

MoveObject("VL",OBJ_HLINE,Time[0],Lower_Limit,Time[0],Lower_Limit,Violet,1,STYLE_SOLID);
SetObjectText("VL_txt","VL Zone","Arial",7,Black);
MoveObject("VL_txt",OBJ_TEXT,Time[0],Lower_Limit,Time[0],Lower_Limit,Violet);
//+---------------------------------------------------------------------------------------+

   double st1=iStdDev(0,0,14,0,MODE_SMA,PRICE_CLOSE,1);

if(Hour()==StartHour+gmt_offset && Pending_Trades==false && Open_Trades==false && Traded_Today==false
) // at 1600 and no trades already open or pending
{

   //Upper_Limit=NormalizeDouble(MathMax(High[1],High[2]),Dealer_Digits); // only works on M60 timeframe?
   //Lower_Limit=NormalizeDouble(MathMin(Low[1],Low[2]),Dealer_Digits);

   double Halfway=NormalizeDouble((Upper_Limit+Lower_Limit)/2,Dealer_Digits);
   
   OrderSend(Symbol(),OP_BUYSTOP,Lots,Upper_Limit,3,
   Halfway
   ,NormalizeDouble(Upper_Limit+(Upper_Limit-Halfway)*1.318,Digits)
   ,NULL,Magic,0,Blue);
    
    
   OrderSend(Symbol(),OP_SELLSTOP,Lots,Lower_Limit,3,
   Halfway
   ,NormalizeDouble(Lower_Limit-(MathAbs(Lower_Limit-Halfway))*1.318,Digits)
   ,NULL,Magic,0,Red);
   Traded_Today=true;
}


return(0);
}

double MM() {
   double lotMM = MathCeil(AccountFreeMargin() *  Risk / 1000) / 100;
   if(AccountIsMicro==false) { //normal account
      if (lotMM < 0.1) lotMM = Lots;
      if ((lotMM > 0.5) && (lotMM < 1)) lotMM=0.5;
      if (lotMM > 1.0) lotMM = MathCeil(lotMM);

      if  (lotMM > 100) lotMM = 100;
      
   } else { //micro account
      if (lotMM < 0.01) lotMM = Lots;
      if (lotMM > 1.0) lotMM = MathCeil(lotMM);
      if  (lotMM > 100) lotMM = 100;
   }
   return (lotMM);
}
   //+-----------------------------------------------------------------------+


void TP()
{
TrailingStop=MarketInfo(Symbol(),MODE_STOPLEVEL)*10000;
int total=OrdersTotal();
   //----TRAILING STOP FUNCTION      
        for(int cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     
  }
}

